Ruby: pm_constant_or_write_node Struct Reference

Ruby 3.4.9p82 (2026-03-11 revision 76cca827ab52ab1d346a728f068d5b8da3e2952b)

Data Fields
pm_constant_or_write_node Struct Reference

ConstantOrWriteNode. More...

`#include <ast.h>`

## Data Fields
pm_node_t | base
| The embedded base node.
pm_constant_id_t | name
| ConstantOrWriteNode#name.
pm_location_t | name_loc
| ConstantOrWriteNode#name_loc.
pm_location_t | operator_loc
| ConstantOrWriteNode#operator_loc.
struct pm_node * | value
| ConstantOrWriteNode#value.
Data Fields inherited from pm_node
pm_node_type_t | type
| This represents the type of the node.
pm_node_flags_t | flags
| This represents any flags on the node.
uint32_t | node_id
| The unique identifier for this node, which is deterministic based on the source.
pm_location_t | location
| This is the location of the node in the source.

## Detailed Description

ConstantOrWriteNode.

Represents the use of the ||= operator for assignment to a constant.

    Target ||= value
    ^^^^^^^^^^^^^^^^

Type: ::PM_CONSTANT_OR_WRITE_NODE

Definition at line 3115 of file ast.h.

## Field Documentation

## ◆ base

pm_node_t pm_constant_or_write_node::base

The embedded base node.

Definition at line 3117 of file ast.h.

Referenced by pm_dump_json().

## ◆ name

pm_constant_id_t pm_constant_or_write_node::name

ConstantOrWriteNode#name.

Definition at line 3123 of file ast.h.

Referenced by pm_dump_json().

## ◆ name_loc

pm_location_t pm_constant_or_write_node::name_loc

ConstantOrWriteNode#name_loc.

Definition at line 3128 of file ast.h.

Referenced by pm_dump_json().

## ◆ operator_loc

pm_location_t pm_constant_or_write_node::operator_loc

ConstantOrWriteNode#operator_loc.

Definition at line 3133 of file ast.h.

Referenced by pm_dump_json().

## ◆ value

struct pm_node* pm_constant_or_write_node::value

ConstantOrWriteNode#value.

Definition at line 3138 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

The documentation for this struct was generated from the following file:

- prism/ast.h